<?php

//var_dump($headers);
function getIdempotencyKey($headers)
{

/*Initialisation de la ressource curl*/
$c = curl_init();
curl_setopt($c, CURLOPT_HTTPHEADER, $headers);

/*On indique à curl quelle url on souhaite télécharger*/
curl_setopt($c, CURLOPT_URL, "https://vms1dev.sep-tech.com/smartsecu-api/api/documentation/idempotency-key");
/*On indique à curl de nous retourner le contenu de la requête plutôt que de l'afficher*/
curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
/*On indique à curl de ne pas retourner les headers http de la réponse dans la chaine de retour*/
curl_setopt($c, CURLOPT_HEADER, false);
/*On execute la requete*/
$output = curl_exec($c);
/*On a une erreur alors on la lève*/
if($output === false)
{
	trigger_error('Erreur curl : '.curl_error($c),E_USER_WARNING);
}
/*Si tout c'est bien passé on affiche le contenu de la requête*/
else
{
    $data = json_decode($output);
    $_SESSION['idempotency-key']=$data->value;
}
/*On ferme la ressource*/ 
curl_close($c);
}


function newTransaction($data,$url,$headers){


    $c = curl_init();
    curl_setopt($c, CURLOPT_HTTPHEADER, $headers);

/*L'url est celle de la page courante pour que le script s'appel lui même*/
curl_setopt($c, CURLOPT_URL,$url);
/*On indique à curl de nous retourner le contenu de la requête plutôt que de l'afficher*/
curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
/*On indique à curl de ne pas retourner les headers http de la réponse dans la chaine de retour*/
curl_setopt($c, CURLOPT_HEADER, false);
/*On indique à curl d'envoyer une requete post*/
curl_setopt($c, CURLOPT_POST,true);
/*On donne les paramêtre de la requete post*/
curl_setopt($c, CURLOPT_POSTFIELDS, http_build_query($data));
/*On execute la requete*/
$output = curl_exec($c);
$httpcode = curl_getinfo($c, CURLINFO_HTTP_CODE);

/*On a une erreur alors on la leve*/
if($output === false)
{
	trigger_error('Erreur curl : '.curl_error($c),E_USER_WARNING);
}
/*Si tout c'est bien passé on affiche le contenu de la requête*/
else
{
    //var_dump($output_decode);
    $output_decode = json_decode($output);

    $_SESSION['uid']= $output_decode->transaction->uid;
    $_SESSION['status'] = $output_decode->easycodes->status;
    $_SESSION['balance'] = $output_decode->easycodes->balance;
    $_SESSION['availableCodes'] = $output_decode->easycodes->availableCodes;
    $_SESSION['failCounter'] = $output_decode->easycodes->failCounter;
    $_SESSION['firstTransactionDate'] =  $output_decode->easycodes->firstTransactionDate;
    $_SESSION['usableDaysAfterFirstTransaction'] = $output_decode->generation->firstTransactionDate;
    

   if($httpcode === 200){
    $sucess = true;


    $msg = "La transaction a été effectué avec succès !";

   }elseif ($httpcode === 202){
    $sucess = false;
    $msg ="HTTP code".$httpcode.": ".$code_error[$httpcode][$output_decode->result];

   }
   
	
}
/*On ferme la ressource*/
curl_close($c);





}



?>