<?php
// On démarre la session AVANT d'écrire du code HTML
session_start();

require_once('error_config.php');
require_once('config.php');

require_once('mylib.php');


//Je génère mon IdempotencyKey
getIdempotencyKey($headers);







//Si on clique sur le bouton valider...
if(isset($_POST['Submit'])){

    $number = $_POST['number'];
    array_push($headers,'Idempotency-Key:'.$_SESSION['idempotency-key']);
    array_push($headers,'accept: application/vnd.septech.api.v1+json');

 
    $url = "https://vms1dev.sep-tech.com/smartsecu-api/api/easycodes/".$number."/transactions";
    //On prepare un tableau avec les données que l'on va envoyer à l'API
    $data = array( 'transactionCode'=>$_POST['transactionCode'],
                    'email'=>$_POST['email'],
                    'webSiteUrl'=>$_POST['webSiteUrl'],
                    'amount'=>$_POST['amount'],
                    'contract'=>$_POST['contract'],
                    'reference'=>$_POST['reference'],
                    'dryRun'=>$_POST['dryRunt']
    );

$data = http_build_query($data);


//On stock en Session le number,transaction code et email pour ne pas avoir à resaissir ses informations à chaque transactions

$_SESSION['number']= $_POST['number'];
$_SESSION['transactionCode']= $_POST['transactionCode'];
$_SESSION['email']= $_POST['email'];


$ch = curl_init();

$url = "https://vms1dev.sep-tech.com/smartsecu-api/api/easycodes/".$_POST['number']."/transactions?".$data;

curl_setopt($ch, CURLOPT_URL,$url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POST, 1);

$headers = array();
$headers[] ='Authorization: Basic '. base64_encode("05507904-022d-4f98-9775-1aa54aedcdaf:TB*e3155e7207tb55!");
$headers[] = "Accept: application/vnd.septech.api.v1+json";
$headers[] = "Idempotency-Key:".$_SESSION['idempotency-key'];
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close ($ch);

/*On a une erreur alors on la leve*/
if($result === false)
{
	trigger_error('Erreur curl : '.curl_error($c),E_USER_WARNING);
}
/*Si tout c'est bien passé on affiche le contenu de la requête*/
else
{
    $output_decode = json_decode($result);

    $uid= $output_decode->transaction->uid;
    $status = $output_decode->easycodes->status;
    $balance = $output_decode->easycodes->balance;
    $availableCodes = $output_decode->easycodes->availableCodes;
    $failCounter = $output_decode->easycodes->failCounter;
    $firstTransactionDate =  $output_decode->easycodes->firstTransactionDate;
    $usableDaysAfterFirstTransaction = $output_decode->generation->firstTransactionDate;
    

   if($httpcode === 200){
    $sucess = true;

if(isset($uid))
  $msg = "La transaction réelle a été effectuée avec succès !";
else
  $msg = "La transaction test a été effectuée avec succès !";


   }elseif ($httpcode === 202){
    $sucess = false;
    $msg ="HTTP code".$httpcode.": ".$code_error[$httpcode][$output_decode->result];

   }
   
	
}
/*On ferme la ressource*/
curl_close($c);

}

?><head>

<title>Test carte </title>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

</head>








<table width="68%" border="0" align="center" height="633">

  <tr> 

    <td height="751"> <html:form action="/admin/smartcodes/test" focus="smartcodesId"> 

   

      <form name="easycodepayement" method="post" action="">

        <div align="center"> 

          <table width="100%" border="0">

            <tr> 

              <td colspan="2"> <div align="center"><font size="+1" face="Arial, Helvetica, sans-serif" color="#0000CC">Informations

                  saisies par l'utilisateur</font></div></td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">N&deg; 

                de carte :</font></td>

              <td width="65%"> <input name="number" value="<?php echo $_SESSION['number']  ?>" type="text" size="20" maxlength="13"> 
              exemple de num&eacute;ro de carte  </td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">Code de 

                Transaction :</font></td>

              <td width="65%"> <input type="text" name="transactionCode" value="<?php echo $_SESSION['transactionCode']  ?>"  size="20" maxlength="4">
                &agrave; chaque transaction un nouveau code </td>

            </tr>

            <tr> 

              <td width="35%">&nbsp;</td>

              <td width="65%">&nbsp; </td>

            </tr>

            <tr> 

              <td colspan="2"> <div align="center"><font size="+1" face="Arial, Helvetica, sans-serif" color="#FF0000">Informations

                  saisies par le site marchand</font></div></td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">email:</font></td>

              <td width="65%"> 

                <input type="input" name="email" value="<?php echo $_SESSION['email']  ?>" >

              </td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">Site Webs 

                :</font></td>

              <td width="65%"> 

                <input type="input" name="webSiteUrl" value="www.cartejetable.com" >

              </td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">Montant 

                :</font></td>

              <td width="65%"> 

                <input type="input" name="amount" value="1.50" >

              </td>

            </tr>

            <tr>

              <td width="35%"><font face="Arial, Helvetica, sans-serif">Idempotency-Key 

                : </font></td>

              <td width="65%"><? if (isset($_SESSION['idempotency-key'])): ?><?php echo $_SESSION['idempotency-key']?><? else: ?> Idempotency-Key   <? endif; ?>       
              <input type="submit" name="generate" id="generate" value="généré"></td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">Contrat 

                :</font></td>

              <td width="65%"> 

                <input type="input" name="contract" value="test" >

              </td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">R&eacute;f&eacute;rence 

                client :</font></td>

              <td width="65%"> 

                <input type="input" name="reference" value="achat site" >

              </td>

            </tr>

            <tr> 

              <td width="35%"><font face="Arial, Helvetica, sans-serif">Test transaction</font></td>

              <td width="65%"> <select name="dryRunt">

                  <option value="false">transaction-réelle</option>
                  <option value="true">test transaction</option>

				 


              </select> </td>

            </tr>

            <tr> 

              <td width="35%">&nbsp;</td>

              <td width="65%"> <input type="submit" name="Submit" value="Valider"> 

              <input type="hidden" name="service" value="easycodes"> </td>

            </tr>

          </table>

          <p style="text-align: center"><br>
          
                 <?php if($sucess) : ?>
                <p style="text-align: center;color:green"><?php echo $msg   ?></p>
                <p style="text-align: center;color:">Numéro de transaction: <?php echo $uid   ?></p>
                <p style="text-align: center;color:">Etat de la carte: <?php echo $status   ?></p>
                <p style="text-align: center;color:">Solde: <?php echo $balance   ?></p>
                <p style="text-align: center;color:">Nombre de codes de transaction disponibles: <?php echo $availableCodes   ?></p>
                <p style="text-align: center;color:">Nombres d'échecs: <?php echo $failCounter   ?></p>
                <p style="text-align: center;color:">Date de la première transaction: <?php echo $firstTransactionDate    ?></p>
                <p style="text-align: center;color:">Nombre de jours utilisables après la première transaction: <?php echo $usableDaysAfterFirstTransaction    ?></p>
                
                
                <?php else : ?>
                  <p style="text-align: center;color:red"><?php echo $msg ?></p>
                  
                  <?php if($uid) : ?>
                   <p style="text-align: center;color:">Numéro de transaction: <?php echo $uid   ?></p>
                  <?php endif; ?>
                  
                  <?php if($status) : ?>
                    <p style="text-align: center;color:">Etat de la carte: <?php echo $status   ?></p>
                  <?php endif; ?>

                  <?php if($balance) : ?>
                    <p style="text-align: center;color:">Crédit restant: <?php echo $balance   ?></p>
                  <?php endif; ?>

                  <?php if($availableCodes) : ?>
                    <p style="text-align: center;color:">Code de transaction disponible: <?php echo $availableCodes   ?></p>
                  <?php endif; ?>
                  
                  <?php if($failCounter) : ?>
                    <p style="text-align: center;color:">Nombres d'erreur de code: <?php echo $failCounter   ?></p>
                  <?php endif; ?>
                  
                  <?php if($firstTransactionDate) : ?>
                    <p style="text-align: center;color:">Date première transaction: <?php echo $firstTransactionDate    ?></p>
                  <?php endif; ?>
                  
                  <?php if($usableDaysAfterFirstTransaction) : ?>
                    <p style="text-align: center;color:">Nombre de jours utilisable après la première transaction: <?php echo $usableDaysAfterFirstTransaction    ?></p>
                  <?php endif; ?>

                <?php endif; ?>
          
        
        
        </p>
        </div>

    </form></td>
  </tr>

</table>


</body>



