<?php
require_once('../mylib.php');

getIdempotencyKey($headers);




if(isset($_POST['submit'])){


$uid = $_POST['uid'];
array_push($headers,'Idempotency-Key:'.$_SESSION['idempotency-key']);

//On prepare un tableau avec les données que l'on va envoyer à l'API
$data = array(  
                'reference'=>$_POST['reference'],
);

$data = http_build_query($data);



$ch = curl_init();

$url = "https://www.septechnology.com/smartsecu-api/api/smartcodes/transactions/".$uid."/cancellation?".$data;
curl_setopt($ch, CURLOPT_URL,$url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POST, 1);


$headers[] = "Idempotency-Key:".$_SESSION['idempotency-key'];
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close ($ch);

/*On a une erreur alors on la leve*/
if($result === false)
{
	trigger_error('Erreur curl : '.curl_error($c),E_USER_WARNING);
}
/*Si tout c'est bien passé on affiche le contenu de la requête*/
else
{
    $output_decode = json_decode($result);

    $uid= $output_decode->transaction->uid;
    $status = $output_decode->easycodes->status;
    $balance = $output_decode->easycodes->balance;
    $availableCodes = $output_decode->easycodes->availableCodes;
    $availableCodesGen = $output_decode->easycodes->generation->availableCodes;
    $maximumAmount = $output_decode->easycodes->generation->maximumAmount;
    $type = $output_decode->easycodes->generation->type;



    $creditGen = $output_decode->easycodes->generation->credit;


    $failCounter = $output_decode->easycodes->failCounter;
    $firstTransactionDate =  $output_decode->easycodes->firstTransactionDate;
    $usableDaysAfterFirstTransaction = $output_decode->generation->usableDaysAfterFirstTransaction;
    

   if($httpcode === 200){
    $sucess = true;

    $msg ="la transaction a été annulée avec succès";



   }elseif ($httpcode === 202){
    $sucess = false;
    $msg ="HTTP code".$httpcode.": ".$code_error[$httpcode][$output_decode->result];

   }
   
	
}
/*On ferme la ressource*/
curl_close($c);

}

//On stock en Session le number,transaction code et email pour ne pas avoir à resaissir ses informations à chaque transactions







?>


<!doctype html>
<!--[if lt IE 7]> <html class="ie6 oldie"> <![endif]-->
<!--[if IE 7]>    <html class="ie7 oldie"> <![endif]-->
<!--[if IE 8]>    <html class="ie8 oldie"> <![endif]-->
<!--[if gt IE 8]><!-->
<html class="">
<!--<![endif]-->
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>menuservices</title>
<link href="../boilerplate.css" rel="stylesheet" type="text/css">
<link href="../menu services.css" rel="stylesheet" type="text/css">
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css" integrity="sha384-WskhaSGFgHYWDcbwN70/dfYBj47jz9qbsMId/iRN3ewGhXQFZCSftd1LZCfmhktB" crossorigin="anonymous">

<!-- 
To learn more about the conditional comments around the html tags at the top of the file:
paulirish.com/2008/conditional-stylesheets-vs-css-hacks-answer-neither/

Do the following if you're using your customized build of modernizr (http://www.modernizr.com/):
* insert the link to your js here
* remove the link below to the html5shiv
* add the "no-js" class to the html tags at the top
* you can also remove the link to respond.min.js if you included the MQ Polyfill in your modernizr build 
-->
<!--[if lt IE 9]>
<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->
<script src="respond.min.js"></script>
<script
  src="https://code.jquery.com/jquery-3.3.1.min.js"
  integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8="
  crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js" integrity="sha384-smHYKdLADwkXOn1EmN1qk/HfnUcbVRZyYmZ4qpPea6sjB/pTJ0euyQp0Mk8ck+5T" crossorigin="anonymous"></script>
  <script src="../main.js"></script>

</head>
<body>
<div class="gridContainer clearfix">
<h1 class="display-1">Annuler une transaction</h1>
<div class="center">
    <form method="post" action="" > 

                 <div class="form-group row">
                      <div class="col-sm-4 center">
                          <input name="uid"  type="text" class="form-control" id="uid" placeholder="UID de la transaction" required>
                      </div>
                  </div>

                

                  <div class="form-group row">
                      <div class="col-sm-4 center">
                          <input  name="reference" type="text" class="form-control" id="" placeholder="Référence client" required>
                      </div>
                  </div>



                  <div  class="fluid2">
                    <button type="submit" id="singlebutton" name="submit" class="btn btn-primary center-block">Valider</button>
                  </div>
    
    </form>
</div>

 <div class="fluid2">

      <?php if($sucess) : ?>
                <p style="text-align: center;color:green"><?php echo $msg   ?></p>
                <p style="text-align: center;color:">Numéro de transaction: <?php echo $uid   ?></p>
                <p style="text-align: center;color:">Etat de la carte: <?php echo $status   ?></p>
                <p style="text-align: center;color:">Crédit de la carte à l'origine: <?php echo $creditGen   ?></p>
                <p style="text-align: center;color:">Solde: <?php echo $balance   ?></p>
                <p style="text-align: center;color:">Nombre de codes total sur la carte:  <?php echo $availableCodesGen   ?></p>
                <p style="text-align: center;color:">Nombre de code de transaction disponibles: <?php echo $availableCodes   ?></p>
                <p style="text-align: center;color:">Dépense maximum par transaction:  <?php echo $maximumAmount   ?></p>

                <p style="text-align: center;color:">Nombres d'échecs: <?php echo $failCounter   ?></p>
                <p style="text-align: center;color:">Date de la première transaction: <?php echo $firstTransactionDate    ?></p>
                <?php if($usableDaysAfterFirstTransaction) : ?>
                  <p style="text-align: center;color:">Nombre de jours valides apres la premiere transaction: <?php echo $usableDaysAfterFirstTransaction    ?></p>
                <?php endif; ?>
                <p style="text-align: center;color:">Type: <?php echo $type    ?></p>

                
                
                <?php else : ?>

                  <p style="text-align: center;color:red"><?php echo $msg ?></p>

                <?php endif; ?>
  </div>

</div>
</body>
</html>
